
/* Network traffic analyzer
 * (c) 2001, Emil Mikulic.
 */

/* Big numbers - "arbitrary precision" arithmetic using strings */

#ifndef __BIGNUM_H
#define __BIGNUM_H

#include "version.h"

#define TWOPOW32 "4294967296"

typedef struct {
	dword hi, lo;
} i64;



inline dword num_from_char(const byte c);

/* note: output needs to be deallocated */
inline char *copy_str(const char *s);

/* note: output needs to be deallocated */
inline char *bignum_from_int(const dword n);

/* note: output needs to be deallocated */
inline char *add_bignum(char *a, char *b);

/* note: output needs to be deallocated */
inline char *mul_bignum(char *a, char *b);

inline void add_64bit(i64 *dest, const dword src);
inline void sub_64bit(i64 *dest, const dword src);

/* note: output needs to be deallocated */
inline char *bignum_from_64bit(const i64 val);

inline double db_div_64_d(const i64 num, const dword denom);
inline int i_div_64_db(const i64 num, const double denom);

inline int smaller_64(const i64 a, const i64 b);
inline int bigger_64(const i64 a, const i64 b);
inline i64 max_64(const i64 a, const i64 b);
inline i64 min_64(const i64 a, const i64 b);

inline char *add_commas(char *str, int want_free);

#endif

