
/* darkstat: a network traffic analyzer
 * (c) 2001, Emil Mikulic.
 */

/* string arithmetic for web interface */

#include "content.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <assert.h>



content *c_new(void)
{
	content *c = (content*)malloc(sizeof(content));

	c->pool = CONTENT_POOL_START;
	c->buf = (char*)malloc(CONTENT_POOL_START);
	if (!c->buf) freakout("not enough memory for content buffer in c_new()");
	c->buf[0] = 0;

	return c;
}



void c_delete(content **c)
{
	free((*c)->buf);
	free(*c);
	*c = NULL;
}



inline void c_append(content *c, const char *format, ...)
{
	int len1, len2;
	char buf[CONTENT_POOL_GROW];
	va_list va;

	assert(c != NULL);
	assert(c->buf != NULL);

	va_start(va, format);
	len2 = vsnprintf(buf, CONTENT_POOL_GROW, format, va);
	if (len2 == -1) freakout("buffer overflow in c_append()");
	va_end(va);

	len1 = strlen(c->buf);
	len2 += len1 + 1;

	if (len2 > c->pool)
	{
		c->pool += CONTENT_POOL_GROW;
		c->buf = realloc(c->buf, c->pool);
		if (c->buf == NULL) freakout("realloc() failed in c_append()");
	}

	if (len1 == 0) strcpy(c->buf, buf); else
		strcat(c->buf, buf);
}

