
/* Network traffic analyzer
 * (c) 2001, Emil Mikulic.
 */

#ifndef __PROTO_DB_H
#define __PROTO_DB_H

#include "db.h"
#include "bignum.h"
#include <stdio.h>

typedef struct {
	byte protocol;
	i64 data_in, data_out;
} proto_record;



/* Global database */
extern db proto_db;



void proto_db_init(void);
void proto_db_free(void);

/* needs to be deallocated when it's no longer needed */
inline proto_record *proto_make(const byte protocol);

/* add or update a protocol, depending on whether it exists in the db or not */
inline void proto_transfer_in(const byte proto, const dword in);
inline void proto_transfer_out(const byte proto, const dword out);

void proto_db_dump(FILE *fp);



inline char *proto_name(const byte protocol);
inline char *proto_name_short(const byte protocol);

#endif
